#include <vector>

#include <Eigen/StdVector>

#include <Eigen/Core>
#include <Eigen/Geometry>

USING_PART_OF_NAMESPACE_EIGEN

struct Foo
{
	Foo(int a) : m_a(a), m_v(1.0,2.0) {}
	int m_a;
	Vector2d m_v;

	EIGEN_MAKE_ALIGNED_OPERATOR_NEW
};

int main(int argc, char* argv[])
{
  // Does not even compile anymore under VS.net due to the declspec error.
	// std::vector<Vector2d> std_vector;

	{
		std::vector<Vector2d, Eigen::aligned_allocator<Vector2d> > std_vector;

		Vector2d v(1,2);
		std_vector.push_back(v);

		Matrix2d m = Matrix2d::Identity(2,2);
		std_vector.push_back(m*v);
	}

	{
		std::vector<Foo, Eigen::aligned_allocator<Foo> > std_vector;
		std_vector.push_back(5);
	}

	{
		std::vector<Vector2d, Eigen::aligned_allocator<Vector2d> > std_vector(5);
	}

	{
		std::vector<Vector2d, Eigen::aligned_allocator<Vector2d> > std_vector(5, Vector2d(0,0));
		std_vector.resize(7);
		std_vector.resize(5);
		std_vector.resize(7, Vector2d(0,0));
	}
}
